Index: serefpolicy-contrib-20140730/vbetool.te
===================================================================
--- serefpolicy-contrib-20140730.orig/vbetool.te
+++ serefpolicy-contrib-20140730/vbetool.te
@@ -27,6 +27,7 @@ role vbetool_roles types vbetool_t;
 #
 
 allow vbetool_t self:capability { dac_override sys_tty_config sys_admin };
+allow vbetool_t self:capability2 compromise_kernel;
 allow vbetool_t self:process execmem;
 
 dev_wx_raw_memory(vbetool_t)
@@ -43,7 +44,6 @@ mls_file_write_all_levels(vbetool_t)
 
 term_use_unallocated_ttys(vbetool_t)
 
-miscfiles_read_localization(vbetool_t)
 
 tunable_policy(`vbetool_mmap_zero_ignore',`
 	dontaudit vbetool_t self:memprotect mmap_zero;
Index: serefpolicy-contrib-20140730/vdagent.if
===================================================================
--- serefpolicy-contrib-20140730.orig/vdagent.if
+++ serefpolicy-contrib-20140730/vdagent.if
@@ -24,15 +24,15 @@ interface(`vdagent_domtrans',`
 ##	Get attributes of vdagent executable files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+##  <summary>
 ##	Domain allowed access.
-##	</summary>
+##  </summary>
 ## </param>
 #
 interface(`vdagent_getattr_exec_files',`
-	gen_require(`
-		type vdagent_exec_t;
-	')
+    gen_require(`
+        type vdagent_exec_t;
+    ')
 
 	allow $1 vdagent_exec_t:file getattr_file_perms;
 ')
@@ -42,18 +42,18 @@ interface(`vdagent_getattr_exec_files',`
 ##	Get attributes of vdagent log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
 interface(`vdagent_getattr_log',`
-	gen_require(`
-		type vdagent_log_t;
-	')
+    gen_require(`
+        type vdagent_log_t;
+    ')
 
-	logging_search_logs($1)
-	allow $1 vdagent_log_t:file getattr_file_perms;
+    logging_search_logs($1)
+    allow $1 vdagent_log_t:file getattr_file_perms;
 ')
 
 ########################################
@@ -81,18 +81,18 @@ interface(`vdagent_read_pid_files',`
 ##	domain stream socket.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##      <summary>
+##      Domain allowed access.
+##      </summary>
 ## </param>
 #
 interface(`vdagent_stream_connect',`
-	gen_require(`
-		type vdagent_var_run_t, vdagent_t;
-	')
+        gen_require(`
+                type vdagent_var_run_t, vdagent_t;
+        ')
 
-	files_search_pids($1)
-	stream_connect_pattern($1, vdagent_var_run_t, vdagent_var_run_t, vdagent_t)
+        files_search_pids($1)
+        stream_connect_pattern($1, vdagent_var_run_t, vdagent_var_run_t, vdagent_t)
 ')
 
 ########################################
@@ -110,7 +110,6 @@ interface(`vdagent_stream_connect',`
 ##	Role allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
 interface(`vdagent_admin',`
 	gen_require(`
@@ -120,6 +119,9 @@ interface(`vdagent_admin',`
 
 	allow $1 vdagent_t:process signal_perms;
 	ps_process_pattern($1, vdagent_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 vdagent_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, vdagentd_initrc_exec_t)
 	domain_system_change_exemption($1)
Index: serefpolicy-contrib-20140730/vdagent.te
===================================================================
--- serefpolicy-contrib-20140730.orig/vdagent.te
+++ serefpolicy-contrib-20140730/vdagent.te
@@ -1,4 +1,4 @@
-policy_module(vdagent, 1.2.0)
+policy_module(vdagent, 1.1.1)
 
 ########################################
 #
@@ -25,6 +25,7 @@ logging_log_file(vdagent_log_t)
 
 dontaudit vdagent_t self:capability sys_admin;
 allow vdagent_t self:process signal;
+
 allow vdagent_t self:fifo_file rw_fifo_file_perms;
 allow vdagent_t self:unix_stream_socket { accept listen };
 
@@ -39,23 +40,26 @@ create_files_pattern(vdagent_t, vdagent_
 setattr_files_pattern(vdagent_t, vdagent_log_t, vdagent_log_t)
 logging_log_filetrans(vdagent_t, vdagent_log_t, file)
 
+kernel_request_load_module(vdagent_t)
+
 dev_rw_input_dev(vdagent_t)
 dev_rw_mtrr(vdagent_t)
 dev_read_sysfs(vdagent_t)
 dev_dontaudit_write_mtrr(vdagent_t)
 
-files_read_etc_files(vdagent_t)
-
 term_use_virtio_console(vdagent_t)
 
 init_read_state(vdagent_t)
 
-logging_send_syslog_msg(vdagent_t)
+systemd_read_logind_sessions_files(vdagent_t)
+systemd_login_read_pid_files(vdagent_t)
 
-miscfiles_read_localization(vdagent_t)
+logging_send_syslog_msg(vdagent_t)
 
 userdom_read_all_users_state(vdagent_t)
 
+xserver_read_xdm_state(vdagent_t)
+
 optional_policy(`
 	dbus_system_bus_client(vdagent_t)
 
Index: serefpolicy-contrib-20140730/vhostmd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/vhostmd.if
+++ serefpolicy-contrib-20140730/vhostmd.if
@@ -216,9 +216,13 @@ interface(`vhostmd_admin',`
 		type vhostmd_tmpfs_t;
 	')
 
-	allow $1 vhostmd_t:process { ptrace signal_perms };
+	allow $1 vhostmd_t:process signal_perms;
 	ps_process_pattern($1, vhostmd_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 vhostmd_t:process ptrace;
+	')
+
 	vhostmd_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 vhostmd_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/vhostmd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/vhostmd.te
+++ serefpolicy-contrib-20140730/vhostmd.te
@@ -58,14 +58,11 @@ dev_read_urand(vhostmd_t)
 dev_read_sysfs(vhostmd_t)
 
 files_list_tmp(vhostmd_t)
-files_read_usr_files(vhostmd_t)
 
 auth_use_nsswitch(vhostmd_t)
 
 logging_send_syslog_msg(vhostmd_t)
 
-miscfiles_read_localization(vhostmd_t)
-
 optional_policy(`
 	hostname_exec(vhostmd_t)
 ')
@@ -77,6 +74,7 @@ optional_policy(`
 
 optional_policy(`
 	virt_stream_connect(vhostmd_t)
+	virt_write_content(vhostmd_t)
 ')
 
 optional_policy(`
Index: serefpolicy-contrib-20140730/virt.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/virt.fc
+++ serefpolicy-contrib-20140730/virt.fc
@@ -1,51 +1,92 @@
-HOME_DIR/\.libvirt(/.*)?	gen_context(system_u:object_r:virt_home_t,s0)
-HOME_DIR/\.libvirt/qemu(/.*)?	gen_context(system_u:object_r:svirt_home_t,s0)
-HOME_DIR/\.virtinst(/.*)?	gen_context(system_u:object_r:virt_home_t,s0)
-HOME_DIR/VirtualMachines(/.*)?	gen_context(system_u:object_r:virt_home_t,s0)
-HOME_DIR/VirtualMachines/isos(/.*)?	gen_context(system_u:object_r:virt_content_t,s0)
+HOME_DIR/\.libvirt(/.*)? 	gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/\.libvirt/qemu(/.*)? 	gen_context(system_u:object_r:svirt_home_t,s0)
+HOME_DIR/\.virtinst(/.*)? 	gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/\.cache/libvirt(/.*)? 	gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/\.cache/libvirt-sandbox(/.*)? gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/\.cache/gnome-boxes(/.*)? gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/\.cache/libvirt/qemu(/.*)? 	gen_context(system_u:object_r:svirt_home_t,s0)
+HOME_DIR/\.config/libvirt(/.*)? 	gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/\.config/libvirt/qemu(/.*)? 	gen_context(system_u:object_r:svirt_home_t,s0)
+HOME_DIR/VirtualMachines(/.*)? 	gen_context(system_u:object_r:virt_home_t,s0)
+HOME_DIR/VirtualMachines/isos(/.*)? gen_context(system_u:object_r:virt_content_t,s0)
+HOME_DIR/\.local/share/gnome-boxes/images(/.*)? gen_context(system_u:object_r:svirt_home_t,s0)
 
-/etc/libvirt	-d	gen_context(system_u:object_r:virt_etc_t,s0)
+/etc/libvirt		-d	gen_context(system_u:object_r:virt_etc_t,s0)
 /etc/libvirt/[^/]*	--	gen_context(system_u:object_r:virt_etc_t,s0)
 /etc/libvirt/[^/]*	-d	gen_context(system_u:object_r:virt_etc_rw_t,s0)
-/etc/libvirt/.*/.*	gen_context(system_u:object_r:virt_etc_rw_t,s0)
+/etc/libvirt/.*/.*		gen_context(system_u:object_r:virt_etc_rw_t,s0)
+/etc/rc\.d/init\.d/libvirtd --	gen_context(system_u:object_r:virtd_initrc_exec_t,s0)
+/etc/xen		-d	gen_context(system_u:object_r:virt_etc_t,s0)
+/etc/xen/[^/]*		--	gen_context(system_u:object_r:virt_etc_t,s0)
+/etc/xen/[^/]*		-d	gen_context(system_u:object_r:virt_etc_rw_t,s0)
+/etc/xen/.*/.*			gen_context(system_u:object_r:virt_etc_rw_t,s0)
 
-/etc/rc\.d/init\.d/(libvirt-bin|libvirtd)	--	gen_context(system_u:object_r:virtd_initrc_exec_t,s0)
+/usr/libexec/libvirt_lxc --	gen_context(system_u:object_r:virtd_lxc_exec_t,s0)
+/usr/libexec/qemu-bridge-helper		gen_context(system_u:object_r:virt_bridgehelper_exec_t,s0)
 
-/etc/xen	-d	gen_context(system_u:object_r:virt_etc_t,s0)
-/etc/xen/[^/]*	--	gen_context(system_u:object_r:virt_etc_t,s0)
-/etc/xen/[^/]*	-d	gen_context(system_u:object_r:virt_etc_rw_t,s0)
-/etc/xen/.*/.*	gen_context(system_u:object_r:virt_etc_rw_t,s0)
-
-/usr/libexec/libvirt_lxc	--	gen_context(system_u:object_r:virtd_lxc_exec_t,s0)
-/usr/libexec/qemu-bridge-helper	gen_context(system_u:object_r:virt_bridgehelper_exec_t,s0)
-
-/usr/bin/virsh	--	gen_context(system_u:object_r:virsh_exec_t,s0)
-/usr/bin/virt-sandbox-service.*	--	gen_context(system_u:object_r:virsh_exec_t,s0)
-
-/usr/sbin/condor_vm-gahp	--	gen_context(system_u:object_r:virtd_exec_t,s0)
-/usr/sbin/fence_virtd	--	gen_context(system_u:object_r:virsh_exec_t,s0)
 /usr/sbin/libvirt-qmf	--	gen_context(system_u:object_r:virt_qmf_exec_t,s0)
 /usr/sbin/libvirtd	--	gen_context(system_u:object_r:virtd_exec_t,s0)
+/usr/sbin/virtlockd --  gen_context(system_u:object_r:virtd_exec_t,s0)
+/usr/bin/virsh		--	gen_context(system_u:object_r:virsh_exec_t,s0)
+/usr/sbin/condor_vm-gahp	--	gen_context(system_u:object_r:virtd_exec_t,s0)
+/usr/sbin/xl		--	gen_context(system_u:object_r:virsh_exec_t,s0)
+/usr/sbin/xm		--	gen_context(system_u:object_r:virsh_exec_t,s0)
 
 /var/cache/libvirt(/.*)?	gen_context(system_u:object_r:virt_cache_t,s0-mls_systemhigh)
 
-/var/lib/libvirt(/.*)?	gen_context(system_u:object_r:virt_var_lib_t,s0)
-/var/lib/libvirt/boot(/.*)?	gen_context(system_u:object_r:virt_content_t,s0)
-/var/lib/libvirt/images(/.*)?	gen_context(system_u:object_r:virt_image_t,s0)
-/var/lib/libvirt/isos(/.*)?	gen_context(system_u:object_r:virt_content_t,s0)
-/var/lib/libvirt/qemu(/.*)?	gen_context(system_u:object_r:svirt_var_run_t,s0-mls_systemhigh)
-
-/var/log/log(/.*)?	gen_context(system_u:object_r:virt_log_t,s0)
-/var/log/libvirt(/.*)?	gen_context(system_u:object_r:virt_log_t,s0)
-/var/log/vdsm(/.*)?	gen_context(system_u:object_r:virt_log_t,s0)
+/var/lib/libvirt(/.*)?		gen_context(system_u:object_r:virt_var_lib_t,s0)
+/var/lib/libvirt/boot(/.*)? 	gen_context(system_u:object_r:virt_content_t,s0)
+/var/lib/libvirt/images(/.*)? 	gen_context(system_u:object_r:virt_image_t,s0)
+/var/lib/libvirt/isos(/.*)? 	gen_context(system_u:object_r:virt_content_t,s0)
+/var/lib/libvirt/qemu(/.*)? 	gen_context(system_u:object_r:qemu_var_run_t,s0-mls_systemhigh)
+
+/var/lock/xl		--	gen_context(system_u:object_r:virt_log_t,s0)
+/var/log/log(/.*)?		gen_context(system_u:object_r:virt_log_t,s0)
+/var/log/libvirt(/.*)?		gen_context(system_u:object_r:virt_log_t,s0)
+/var/log/vdsm(/.*)?		gen_context(system_u:object_r:virt_log_t,s0)
+/var/run/libvirtd\.pid	--	gen_context(system_u:object_r:virt_var_run_t,s0)
+/var/run/libvirt(/.*)?		gen_context(system_u:object_r:virt_var_run_t,s0)
+/var/run/libvirt/qemu(/.*)? 	gen_context(system_u:object_r:qemu_var_run_t,s0-mls_systemhigh)
+/var/run/libvirt/lxc(/.*)?	gen_context(system_u:object_r:virt_lxc_var_run_t,s0)
+/var/run/libvirt-sandbox(/.*)?	gen_context(system_u:object_r:virt_lxc_var_run_t,s0)
+/var/run/vdsm(/.*)?		gen_context(system_u:object_r:virt_var_run_t,s0)
+
+/var/vdsm(/.*)?			gen_context(system_u:object_r:virt_var_run_t,s0)
+
+# support for AEOLUS project
+/usr/bin/imagefactory		--			gen_context(system_u:object_r:virtd_exec_t,s0)
+/usr/bin/imgfac\.py		--			gen_context(system_u:object_r:virtd_exec_t,s0)
+/var/cache/oz(/.*)?					gen_context(system_u:object_r:virt_cache_t,s0)
+/var/lib/imagefactory/images(/.*)?	gen_context(system_u:object_r:virt_image_t,s0)
+/var/lib/oz(/.*)?					gen_context(system_u:object_r:virt_var_lib_t,s0)
+/var/lib/oz/isos(/.*)?				gen_context(system_u:object_r:virt_content_t,s0)
+/var/lib/vdsm(/.*)?				gen_context(system_u:object_r:virt_content_t,s0)
+
+# add support vios-proxy-*
+/usr/bin/vios-proxy-host	--	gen_context(system_u:object_r:virtd_exec_t,s0)
+/usr/bin/vios-proxy-guest	--  gen_context(system_u:object_r:virtd_exec_t,s0)
+
+# support for nova-stack
+/usr/bin/nova-compute       --  gen_context(system_u:object_r:virtd_exec_t,s0)
+/usr/bin/qemu		--	gen_context(system_u:object_r:qemu_exec_t,s0)
+/usr/bin/qemu-system-.*	--	gen_context(system_u:object_r:qemu_exec_t,s0)
+/usr/bin/qemu-kvm	--	gen_context(system_u:object_r:qemu_exec_t,s0)
+/usr/libexec/qemu.*	--	gen_context(system_u:object_r:qemu_exec_t,s0)
+
+/etc/qemu-ga/fsfreeze-hook.d(/.*)?      gen_context(system_u:object_r:virt_qemu_ga_unconfined_exec_t,s0)
+/usr/libexec/qemu-ga/fsfreeze-hook.d(/.*)?  gen_context(system_u:object_r:virt_qemu_ga_unconfined_exec_t,s0)
+/var/run/qemu-ga/fsfreeze-hook.d(/.*)?      gen_context(system_u:object_r:virt_qemu_ga_unconfined_exec_t,s0)
+
+/usr/libexec/qemu-ga(/.*)?	gen_context(system_u:object_r:virt_qemu_ga_exec_t,s0)
+
+/usr/lib/systemd/system/virt.*\.service -- gen_context(system_u:object_r:virtd_unit_file_t,s0)
+/usr/lib/systemd/system/libvirt.*\.service -- gen_context(system_u:object_r:virtd_unit_file_t,s0)
+/usr/lib/systemd/system/.*xen.*\.service -- gen_context(system_u:object_r:virtd_unit_file_t,s0)
+
+/usr/bin/qemu-ga                --      gen_context(system_u:object_r:virt_qemu_ga_exec_t,s0)
 
-/var/vdsm(/.*)?		gen_context(system_u:object_r:virt_var_run_t,s0)
+/var/run/qemu-ga\.pid           --      gen_context(system_u:object_r:virt_qemu_ga_var_run_t,s0)
+/var/run/qga\.state             --      gen_context(system_u:object_r:virt_qemu_ga_var_run_t,s0)
 
-/var/run/libguestfs(/.*)?	gen_context(system_u:object_r:virt_var_run_t,s0)
-/var/run/libvirtd\.pid	--	gen_context(system_u:object_r:virt_var_run_t,s0)
-/var/run/libvirt(/.*)?	gen_context(system_u:object_r:virt_var_run_t,s0)
-/var/run/libvirt/lxc(/.*)?	gen_context(system_u:object_r:virtd_lxc_var_run_t,s0)
-/var/run/libvirt-sandbox(/.*)?	gen_context(system_u:object_r:virtd_lxc_var_run_t,s0)
-/var/run/libvirt/qemu(/.*)?	gen_context(system_u:object_r:svirt_var_run_t,s0-mls_systemhigh)
-/var/run/user/[^/]*/libguestfs(/.*)?	gen_context(system_u:object_r:virt_home_t,s0)
-/var/run/vdsm(/.*)?	gen_context(system_u:object_r:virt_var_run_t,s0)
+/var/log/qemu-ga\.log.*           --      gen_context(system_u:object_r:virt_qemu_ga_log_t,s0)
+/var/log/qemu-ga(/.*)?		gen_context(system_u:object_r:virt_qemu_ga_log_t,s0)
